<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template
      #page-content
    >
      <div class="full-height column">
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>
        <q-card
          :square="!isDesktopPlatform"
          class="column no-wrap col"
        >
          <q-card-section>
            <div
              class="text-subtitle1"
            >
              <translate>Summary of parameters:</translate>
            </div>
          </q-card-section>

          <q-scroll-area class="full-width full-height">
            <q-list class="bg-grey-2">
              <!-- target -->
              <q-item dense>
                <q-item-label
                  header
                  class="col-5 q-py-sm"
                  key="plot"
                >
                  <translate>Plot</translate>
                </q-item-label>
                <q-item-section class="col-7 q-py-sm">
                  {{ $store.state.fertilizationPlan.target.name }}
                </q-item-section>
              </q-item>
              <!-- crop -->
              <q-item dense>
                <q-item-label
                  header
                  class="col-5 q-py-sm"
                >
                  <translate>Crop</translate>
                </q-item-label>
                <q-item-section class="col-7 q-py-sm">
                  {{ storePlantSpecies.name }} - {{ storeCropProfile.profile_name }}
                </q-item-section>
              </q-item>
              <!-- greenhouse -->
              <q-item dense>
                <q-item-label
                  header
                  class="col-5 q-py-sm"
                >
                  <translate>Greenhouse area</translate>
                </q-item-label>
                <q-item-section class="col-7 q-py-sm">
                  {{ `${storeGreenhouseSize}${$pgettext('unit', 'm2')}` }}
                </q-item-section>
              </q-item>
              <!-- cropping media -->
              <q-item dense>
                <q-item-label
                  header
                  class="col-5 q-py-sm"
                >
                  <translate>Cropping media</translate>
                </q-item-label>
                <q-item-section class="col-7 q-py-sm">
                  {{ storeCroppingMedia.label }}
                </q-item-section>
              </q-item>
              <!-- planting method -->
              <q-item dense>
                <q-item-label
                  header
                  class="col-5 q-py-sm"
                >
                  <translate>Planting method</translate>
                </q-item-label>
                <q-item-section class="col-7 q-py-sm">
                  {{ storePlantingMethod.label }}
                </q-item-section>
              </q-item>
              <!-- planting dates -->
              <q-item dense>
                <q-item-label
                  header
                  class="col-5 q-py-sm"
                >
                  <translate>Planting dates</translate>
                </q-item-label>
                <q-item-section class="col-7 q-py-sm">
                  {{ displayDate(storePlantingMethodFrom) }} - {{ displayDate(storePlantingMethodTo) }}
                </q-item-section>
              </q-item>
              <!-- whitening -->
              <q-item dense>
                <q-item-label
                  header
                  class="col-5 q-py-sm"
                >
                  <translate>Whitening</translate>
                </q-item-label>
                <q-item-section class="col-7 q-py-sm">
                  {{ storeWhitening ? $gettext('Yes') : $gettext('No') }}
                </q-item-section>
              </q-item>
              <!-- Irrigation layout -->
              <q-item dense>
                <q-item-label
                  header
                  class="col-5 q-py-sm"
                >
                  <translate>Irrigation layout</translate>
                </q-item-label>
                <q-item-section class="col-7 q-py-sm">
                  {{ storeIrrigationLayout.label }}
                </q-item-section>
              </q-item>

              <q-separator />
            </q-list>
          </q-scroll-area>

          <!-- buttons -->
          <q-card-section class="q-mt-auto">
            <q-card-actions
              class="q-pa-none"
              vertical
              align="stretch"
            >
              <q-btn
                color="primary"
                text-color="white"
                @click="onClickCompute"
                :loading="computing"
              >
                <translate>Compute</translate>
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="onClickPrevious"
              >
                <translate>Previous</translate>
              </q-btn>
            </q-card-actions>
          </q-card-section>
        </q-card>
      </div>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { date } from 'quasar'

import { PlatformMixin } from 'src/mixins/PlatformMixin'
import { DateMixin } from 'src/mixins/DateMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'
import queryVegsystRequirements from 'src/pages/fieldbook/fertilization/algorithms/vegsyst/graphql/queryVegsystRequirements'

export default {
  name: 'VegsystComputePage',
  components: {
    GenericLayout,
    Header,
    Footer
  },
  mixins: [PlatformMixin, DateMixin, AlgorithmsMixins],
  data () {
    return {
      computing: false
    }
  },
  computed: {
    pageTitle () {
      return this.$gettext('Compute')
    },
    pageSubTitle () {
      return 'VegSyst'
    },
    storeCroppingMedia () {
      return this.$store.state.fertilizationPlan.parameters.croppingMedia
    },
    storeCropProfile () {
      return this.$store.state.fertilizationPlan.parameters.cropProfile
    },
    storeCustomIrrigationLayouts () {
      return this.$store.state.fertilizationPlan.parameters.customIrrigationLayouts
    },
    storeDrainageFractionValue () {
      return this.$store.state.fertilizationPlan.parameters.drainageFractionValue
    },
    storeEfficiencyCoefficient () {
      return this.$store.state.fertilizationPlan.parameters.efficiencyCoefficient
    },
    storeGreenhouseSize () {
      return this.$store.state.fertilizationPlan.parameters.greenhouseSize
    },
    storeIrrigationLayout () {
      return this.$store.state.fertilizationPlan.parameters.irrigationLayout
    },
    storeManure () {
      return this.$store.state.fertilizationPlan.parameters.manure
    },
    storeManureApplicationDate () {
      return this.$store.state.fertilizationPlan.parameters.manureApplicationDate
    },
    storeManureVolume () {
      return this.$store.state.fertilizationPlan.parameters.manureVolume
    },
    storePlantingMethod () {
      return this.$store.state.fertilizationPlan.parameters.plantingMethod
    },
    storePlantingMethodFrom () {
      return this.$store.state.fertilizationPlan.parameters.plantingMethodFrom
    },
    storePlantingMethodTo () {
      return this.$store.state.fertilizationPlan.parameters.plantingMethodTo
    },
    storePlantSpecies () {
      return this.$store.state.fertilizationPlan.parameters.plantSpecies
    },
    storeSoilBulkDensity () {
      return this.$store.state.fertilizationPlan.parameters.soilBulkDensity
    },
    storeSoilEffectiveRootingDepth () {
      return this.$store.state.fertilizationPlan.parameters.soilEffectiveRootingDepth
    },
    storeSoilOrganicNContent () {
      return this.$store.state.fertilizationPlan.parameters.soilOrganicNContent
    },
    storeSoilMineralNAtPlanting () {
      return this.$store.state.fertilizationPlan.parameters.soilMineralNAtPlanting
    },
    storeSoilNMineralizationRate () {
      return this.$store.state.fertilizationPlan.parameters.soilNMineralizationRate
    },
    storeWhitening () {
      return this.$store.state.fertilizationPlan.parameters.whitening
    },
    storeWhiteningPeriods () {
      return this.$store.state.fertilizationPlan.parameters.whiteningPeriods
    }
  },
  apollo: {
  },
  methods: {
    async onClickCompute () {
      this.computing = true
      try {
        const inputs = {
          greenhouse: {
            size: Number(this.storeGreenhouseSize),
            cropping_media: this.storeCroppingMedia.id,
            uniformity_coefficient: Number(this.storeEfficiencyCoefficient)
          },
          crop_id: Number(this.storeCropProfile.id),
          cropfor: {
            planting_method: this.storePlantingMethod.id,
            transplanting_sowing_date: date.formatDate(this.storePlantingMethodFrom, 'YYYY-MM-DD'),
            end_of_crop_date: date.formatDate(this.storePlantingMethodTo, 'YYYY-MM-DD')
          },
          irrigation: {
            dripper_flow_rate: Number(this.storeIrrigationLayout.dripper_flow_rate),
            distance_between_drippers: Number(this.storeIrrigationLayout.distance_between_drippers),
            dripper_lines: this.storeIrrigationLayout.dripper_lines,
            distance_between_lines: this.storeIrrigationLayout.distance_between_lines ? Number(this.storeIrrigationLayout.distance_between_lines) : undefined,
            distance_between_pairs: this.storeIrrigationLayout.distance_between_pairs ? Number(this.storeIrrigationLayout.distance_between_pairs) : undefined,
            distance_within_pairs: this.storeIrrigationLayout.distance_within_pairs ? Number(this.storeIrrigationLayout.distance_within_pairs) : undefined
          },
          whitening: []
        }
        if (this.storeCroppingMedia.id === 'Sustrato') {
          inputs.salinity = {
            drainage_fraction_value: Number(this.storeDrainageFractionValue)
          }
        } else {
          inputs.soil = {
            soil_bulk_density: Number(this.storeSoilBulkDensity),
            depth_of_soil: Number(this.storeSoilEffectiveRootingDepth),
            soil_oranic_n_values: Number(this.storeSoilOrganicNContent),
            n_mineralization_rate_per_year: Number(this.storeSoilNMineralizationRate),
            soil_mineral_n_at_planting: Number(this.storeSoilMineralNAtPlanting)
          }
          inputs.manure = {
            date_of_most_recent_manure_application: date.formatDate(this.storeManureApplicationDate, 'YYYY-MM-DD'),
            volume_of_manure_applied: Number(this.storeManureVolume),
            manure_id: Number(this.storeManure.id)
          }
        }
        if (this.storeWhitening && this.storeWhiteningPeriods?.length) {
          this.storeWhiteningPeriods.forEach(period => {
            inputs.whitening.push({
              date_of_application: date.formatDate(period.from, 'YYYY-MM-DD'),
              date_of_removal: date.formatDate(period.to, 'YYYY-MM-DD'),
              transmissivity: Number(period.transmissivityValue)
            })
          })
        }
        const results = await this.$apollo.query({
          query: queryVegsystRequirements,
          variables: { inputs },
          fetchPolicy: 'no-cache'
        })
        if (results?.data?.vegsyst__requirements == null) {
          throw new Error('No requirements in data')
        } else {
          this.updateParameter('results', results.data.vegsyst__requirements)
          this.$router.push({
            name: 'vegsystResultsPage'
          })
        }
      } catch (e) {
        console.error(e)
        this.$q.notify({
          color: 'red',
          message: this.$gettext('There was an error while computing the plan.')
        })
      } finally {
        this.computing = false
      }
    },
    onClickPrevious () {
      this.$router.replace({
        name: 'vegsystIrrigationLayoutPage'
      })
    }
  }
}
</script>
